/*
 *
 * Copyright (C) D-Type Solutions - All Rights Reserved
 * Web Site: http://www.d-type.com
 * E-mail: info@d-type.com
 *
 * This file is part of D-Type Engine and may only be used, modified
 * and distributed under the terms of the applicable license agreement
 * For conditions of distribution and use, see license.txt
 *
 * ANY VIOLATIONS OF THE ABOVE LICENSE AGREEMENT WILL BE PROSECUTED TO
 * THE MAXIMUM EXTENT POSSIBLE UNDER THE LAW. NO VENDOR, DISTRIBUTOR,
 * DEALER, RETAILER, SALES PERSON OR OTHER PERSON IS AUTHORIZED TO MODIFY
 * THIS AGREEMENT OR TO MAKE ANY WARRANTY, REPRESENTATION OR PROMISE WHICH
 * IS DIFFERENT THAN, OR IN ADDITION TO, THIS AGREEMENT.
 *
 */


#ifndef DTYPE_FC_ENUM_H
#define DTYPE_FC_ENUM_H


/* Properties */
enum
{
	fcConfigPtr = 10000,
	fcColumnNextPtr = 10011, fcNextColumnPtr = fcColumnNextPtr,
	fcControlPtr = 10029,
	fcProgramPtr = 10030,
	fcConnectionID = 10001,
	fcLockStatus = 10002,
	fcState = 10003,
	fcName = 10004,
	fcValue_08 = 10005, fcValue_8 = fcValue_08,
	fcValue_16 = 10012,
	fcValue_24 = 10013,
	fcValue_32 = 10014,
	fcDw = 10006, fcWidth = fcDw,
	fcDh = 10007, fcHeight = fcDh,
	fcUserParam = 10008,
	fcTabOrderID = 10009,
	fcGroupID = 10010,
	fcUserString = 10017,
	fcCnfLib = 10015,
	fcCnfCharBox = 10016,
	fcCnfCtrlStyleOnFocus = 10020,
	fcCnfCtrlShiftOnFocus = 10021,
	fcCnfButtonNormal = 10050,
	fcCnfButtonPushed = 10051,
	fcCnfRadioButtonNormal = 10060,
	fcCnfRadioButtonPushed = 10061,
	fcCnfRadioButtonSelected = 10062,
	fcCnfCheckBoxNormal = 10070,
	fcCnfCheckBoxPushed = 10071,
	fcCnfCheckBoxSelected = 10072,
	fcCnfSliderNormal = 10080,
	fcCnfSliderPushed = 10081,
	fcItemFirst = 10100, fcFirstItem = fcItemFirst, fcListFirstItem = fcItemFirst,
	fcListSelectedItems = 10101,
	fcListMultiSelect = 10102,
	fcListColOffset = 10103,
	fcAlign = 10104, fcListColAlign = fcAlign,
	fcAlignEnd = 10105,
	fcSliderLimit = 10110,
	fcSliderCoverage = 10111,
	fcSliderPosition = 10112,
	fcOnCtrlRelease = 10200,
	fcOnCtrlChange = 10201,
	fcOnCtrlScroll = 10202,
	fcOnCtrlPush = 10203,
	fcOnCtrlFocusReceive = 10204, fcOnCtrlReceiveFocus = fcOnCtrlFocusReceive,
	fcOnCtrlHold = 10205,
	fcOnCtrlFocusLose = 10206, fcOnCtrlLoseFocus = fcOnCtrlFocusLose,
	fcTextScrollType = 10207,
	fcTextWrapType = 10208,
	fcResizeGuideIndexHor = 10209, /* not documented (used by Dialog's WindowResize) */
	fcResizeGuideIndexVer = 10210, /* not documented (used by Dialog's WindowResize) */
	fcSliderFlags = 10211,
	fcRowFirst = 10212, /* for caching in fcDrawTextBox (304), fcDrawRichTextBox (308) and fcDrawRichListBox (310) */
	fcRowCount = 10213 /* for caching in fcDrawTextBox (304), fcDrawRichTextBox (308) and fcDrawRichListBox (310) */
};


/* Rendering Functions */
enum
{
	fcDrawButton = 10000, fcDrawFirst = fcDrawButton,
	fcDrawRadioButton = 10001,
	fcDrawCheckBox = 10002,
	fcDrawTextBox = 10003,
	fcDrawListBox = 10004,
	fcDrawHSlider = 10005,
	fcDrawVSlider = 10006,
	fcDrawRichTextBox = 10007,
	fcDrawRichButton = 10008,
	fcDrawRichListBox = 10009, fcDrawLast = fcDrawRichListBox
};


#endif /* DTYPE_FC_ENUM_H */
